/*****************************************************************************
 *
 * FILE:	module.h
 * DESCRIPTION:	module header file for wyvern
 * DATE:	Sat, Sep 16 2000
 * AUTHOR:	Kouichi ABE (WALL) / 
 * E-MAIL:	kouichi@MysticWALL.COM
 * URL:		http://www.MysticWALL.COM/cover.html
 * COPYRIGHT:	(C) 2000-2002 졿Kouichi ABE (WALL), All rights reserved.
 * LICENSE:
 *   Copyright (C) 2000-2002 Kouichi ABE (WALL) <kouichi@MysticWALL.COM>,
 *   All rights reserved.
 *  
 *   Redistribution and use in source and binary forms, with or without
 *   modification, are permitted provided that the following conditions
 *   are met:
 *
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in
 *      the documentation and/or other materials provided with the
 *      distribution.
 *
 *   THIS SOFTWARE IS PROVIDED BY KOUICHI ABE (WALL) ``AS IS'' AND ANY
 *   EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *   PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL KOUICHI ABE (WALL) BE
 *   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 *   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 *   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 *   BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 *   WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 *   OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 *   IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: module.h,v 1.14 2002/01/19 14:31:59 kouichi Exp $
 *
 *****************************************************************************/

#ifndef	_module_h
#define	_module_h

/* module name */
#define	MOD_LOG_NAME		"log"
#define	MOD_IDENT_NAME		"ident"
#define	MOD_ACCESS_NAME		"access"
#define	MOD_AUTH_NAME		"auth"
#define	MOD_DIR_NAME		"dir"
#define	MOD_CGI_NAME		"cgi"
#define	MOD_SSI_NAME		"ssi"
#if	HAVE_ZLIB_H
#define	MOD_GZIP_NAME		"gzip"
#endif	/* HAVE_ZLIB_H */

typedef struct _Modules {	/* module management structure */
  struct _mod_log {	/* Log module */
    void *	handle;	/* module handle */
    void	(*write)(Thread *);	
  } log;

  struct _mod_ident {	/* Identification Protocol (RFC1413) module */
    void *	handle;	/* module handle */
    void	(*set)(Thread *);
  } ident;

  struct _mod_access {	/* Access control module */
    void *	handle;	/* module handle */
    bool_t	(*check)(Thread *);
  } access;

  struct _mod_auth {	/* Basic/Digest authentication module */
    void *	handle;	/* module handle */
    bool_t	(*allow)(Thread *);
  } auth;

  struct _mod_dir {	/* Directory listing module */
    void *	handle;	/* module handle */
    void	(*listing)(Thread *);
  } dir;

  struct _mod_cgi {	/* CGI module */
    void *	handle;	/* module handle */
    void	(*run)(Thread *);	
  } cgi;

  struct _mod_ssi {	/* SSI module */
    void *	handle;	/* module handle */
    void	(*run)(Thread *);	
  } ssi;

#if	HAVE_ZLIB_H
  struct _mod_gzip {	/* gzip module */
    void *	handle;	/* module handle */
    void	(*gzcompress)(Thread *);	
  } gzip;

#endif	/* HAVE_ZLIB_H */
} Modules;

#endif	/* _module_h */
