/*****************************************************************************
 *
 * FILE:	fform.h
 * DESCRIPTION:	header file for the file form of directory listing modules
 * DATE:	Mon, May 14 2001
 * AUTHOR:	Kouichi ABE (WALL) / 
 * E-MAIL:	kouichi@MysticWALL.COM
 * URL:		http://www.MysticWALL.COM/cover.html
 * COPYRIGHT:	(C) 2001-2002 졿Kouichi ABE (WALL), All rights reserved.
 * LICENSE:
 *  Copyright (C) 2001-2002 Kouichi ABE (WALL) <kouichi@MysticWALL.COM>,
 *  All rights reserved.
 *  
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in
 *      the documentation and/or other materials provided with the
 *      distribution.
 *
 *   THIS SOFTWARE IS PROVIDED BY KOUICHI ABE (WALL) ``AS IS'' AND ANY
 *   EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *   PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL KOUICHI ABE (WALL) BE
 *   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 *   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 *   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 *   BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 *   WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 *   OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 *   IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: fform.h,v 1.2 2002/01/08 16:18:30 kouichi Exp $
 *
 *****************************************************************************/

#ifndef	_fform_h
#define	_fform_h


/*****************************************************************************
 *
 *	definition of macros and structure
 *
 *****************************************************************************/
typedef enum {		/* file form */
  FF_COMPRESSED,	/* compressed */
  FF_TAR,		/* tar archived */
  FF_ARCHIVE,		/* archived */
  FF_BINARY,		/* binary */
  FF_HTML,		/* HTML */
  FF_TEXT,		/* text */
  FF_PDF,		/* PDF */
  FF_DVI,		/* DVI */
  FF_POSTSCRIPT,	/* PostScript */
  FF_C,			/* C language */
  FF_F77,		/* Fortran language */
  FF_PERL,		/* Perl language */
  FF_TEX,		/* TeX/LaTeX */
  FF_PATCH,		/* patch file */
  FF_SHELL,		/* shell script */
  FF_IMAGE,		/* image */
  FF_MOVIE,		/* movie */
  FF_SOUND		/* sound/audio */
} fform_t;

struct fileForm {
  char *	name;
  fform_t	form;
};


/*****************************************************************************
 *
 *	declaration of global functions
 *
 *****************************************************************************/
extern const struct fileForm *	getFileForm(const char *, unsigned int);

#endif	/* _fform_h */
